#ifndef _BARRIER_H_
#define _BARRIER_H_

#include <pthread.h>

// barrier data structure
typedef struct {
    int counter;
    int flag;
    int num_procs;
    pthread_mutex_t lock;
} barrier_t;

// bar_name must already be allocated
void barrier_init(barrier_t* bar_name, int num_procs);

// sense-reversing barrier code
// local sense should start out FALSE
void barrier(barrier_t* bar_name, int* local_sense);

// bar_name must be allocated and initialized
void barrier_destroy(barrier_t* bar_name);

#endif
